/**************************************************************
 project name		: sc2004tokei
 file name		: main.c                                               
 CPU			: PIC16F873 
 note			: main process
 **************************************************************
	Tools:
	MPLAB v8.92
	XC8 C Compiler V1.20
------------------------------------------------------------

	Pin assignment
	 1:/MCLR
	 2:RA0:0:LCD_D4
	 3:RA1:0:LCD_D5
	 4:RA2:0:LCD_D6
	 5:RA3:0:LCD_D7
	 6:RA4:1:BUZZER
	 7:RA5:0:LCD_E
	 8:Vss
	 9:OSC1
	10:OCS2
	11:RC0:0:LCD_RS
 	12:RC1:0:LCD_RW
	13:RC2:0:NC
	14:SCL

	28:PGD(RB7:SW7)
	27:PGC(RB6:SW6)
	26:RB5:1:CS0(LT6803)
	25:RB4:1:Charge
	24:RB3:1:Discharge
	23:RB2:1:Short
	22:RB1:1:SW1(\)
	21:RB0:1:SW0(\)
	20:Vdd
	19:Vss
	18:Rx(RS232C)
	17:Tx(RS232C)
	16:SDO
	15:SDI



/**************************************************************/

//#define _LEGACY_HEADERS
#include <htc.h>
#include "sci.h"
#include "lcd.h"
#include "main.h"


//#define	SW_RIGHT	RB2 //right key
//#define	SW_LEFT		RB1 //left key
#define	SW_RIGHT	RB6 //right key
#define	SW_LEFT		RB7 //left key

#define	BUZZER		RA4 //uU[@0=ON


#ifdef	CPU1938
	//for pic16f1938
	//__CONFIG(CLKOUTEN_ON & FCMEN_OFF & IESO_OFF & BOREN_ON &  PWRTE_ON & WDTE_OFF & MCLRE_ON &CP_OFF & CPD_OFF & WRT_OFF & LVP_OFF &STVREN_OFF & PLLEN_OFF & FOSC_ECM & VCAPEN_OFF);
	__CONFIG(CLKOUTEN_ON & FCMEN_OFF & IESO_OFF & BOREN_ON &  PWRTE_ON & WDTE_OFF & MCLRE_ON &CP_OFF & CPD_OFF & WRT_OFF & LVP_OFF &STVREN_OFF & PLLEN_OFF & FOSC_ECH & VCAPEN_OFF);
#else
	//for pic16f876/pic16f876a
	__CONFIG(UNPROTECT & LVPDIS & BOREN & PWRTDIS & WDTDIS & HS   & DEBUGEN);
#endif


//Global settings

	unsigned long Totaltime = 32400;	//dOŇoߎ(b) //9:00
	int	msflag ;            	//0.25b̊荞݃tO
	int	lcdcount ;		//LCD̕\[e[V
	
	void lcd_loop(void);
	void sirial_loop(void);
	void clock_set(void);
	unsigned char switchstatus(void);

//------------------int
void interrupt handler( void )	//interrupt handle
{

	if( CCP1IF==1 ){	// 1/4b^C}[

		msflag = 1;			// 250mS̃tO𗧂Ă܂
		CCP1IF=0;			//荞݃tONA 
	}
}


	

//------------------main
main()
{

	GIE = 0;	//O[o荞݋֎~
	CCP1IE=1;	//CCP1荞݋
	PEIE = 1;	//ӊ荞݋
// const char omajinai[] = "ugoke" ; // 삷ׂ̂܂Ȃł

	unsigned char Msec  ;

	PORTA = 0b00010000;	//Port Initalize uU[OFF
	PORTB = 0b11111111;	//Port Initalize 
	PORTC = 0b00000000;	//Port Initalize
	TRISA = 0b00000000; 	//  1=INput 0=OUTput
	TRISB = 0b11111111; 	//
	TRISC = 0b10010000; 	//
#ifdef	CPU1938
	//for pic16f1938
	ANSELA = 0;
	ANSELB = 0;
#else
	//for pic16f876/pic16f876a
	ADCON1 = 0x6;
#endif

	OPTION_REG = 0b00000111; // prescale 1/256 RBPU= EN

//	VAʐMݒ
		unsigned int speed = 38400; //default communication speed set
		sci_Init(speed ,SCI_EIGHT);// Baud set and Bit set


// CCP1 ̐ݒ ----------------------
	T1CON = 0x31;	//16bit[hANbNAvXP[1/8
	CCP1CON=0b001011;    // CCP1荞ݐݒ  
	CCPR1H=0xF4;	//8MHz̎ 4Hz
	CCPR1L=0x23; 	//

	CCP1IE=0;	//CCP1荞ݕs 
	PEIE = 1;	//ӊ荞݋
	GIE = 1;	//O[o荞݋


//LCD init
	delay_ms(200);	//stabilize time
	lcd_init();		//lcd initalize
	lcd_clear();	//lcd clear
	lcd_write(LCD_CursorOff);



//烁C[v

	//CGRAMɂ܂

	lcd_write(0x40);				//CG RAM[hɃZbg

	for(unsigned int j=0; j< 8; j++){
		for(unsigned int i=0; i< 8; i++){
			lcd_cgwrite(lcd_cg[j][i]);
		}
	}




//loop
	while(1){

		msflag=0;
		CCP1IE=1;					//CCP1荞݋ 
			for(unsigned int j=0; j< 65535; j++){
				if (msflag==1){
				break;
				}
			}
		CCP1IE=0;	

		Msec++;				// 250~bJEg܂

		if (Msec >= 4)	{		//I[oTv4
			Msec = 0;
			Totaltime++;
			if (Totaltime >=43200){
				Totaltime = 0;
			}
		}
	
	
	// 0.25b LCD\XV
	// 0.50b RS232Co
	// 0.75b uFv
	// 1.00b v킹

		switch (Msec){
			case 0:
	//			lcd_init();		//lcd initalize
				lcd_loop();
			break;
			case 1:
				sirial_loop();
			break;
			case 2:
				lcd_goto(LCD_LineNumber1 + 9);	//4sڕ\
				lcd_puts(" ");
				lcd_goto(LCD_LineNumber3 + 9);	//4sڕ\
				lcd_puts(" ");
			break;
			default:
				clock_set();
			break;
		}
	}
}



void lcd_loop(void)
{
			lcd_goto(LCD_LineNumber1);	//1sڕ\
			lcd_time(Totaltime,0);
			lcd_goto(LCD_LineNumber2);	//2sڕ\
			lcd_time(Totaltime,1);
			lcd_goto(LCD_LineNumber3);	//3sڕ\
			lcd_time(Totaltime,2);
		//	lcd_goto(LCD_LineNumber4);	//4sڕ\ [`ł̂ŕsv
			lcd_time_4l(Totaltime);
}


void sirial_loop(void)
{
	sci_time(Totaltime);
	sci_PutByte(0x0d);
	sci_PutByte(0x0a);
}

void clock_set(void)
{
	unsigned char  k ;	

	k = switchstatus() ;				// Get switch status 
	if (k == 3){					//Ȃ玞vݒ
		Totaltime = Totaltime / 60;
		Totaltime = Totaltime * 60;		//bȉ؂̂

		while(k != 0){				//L[̂҂
			k = switchstatus() ;
		}

		while(k != 1){				//̐ݒ	Eꂽ玟
			k = switchstatus() ;				// Get switch status 
			if (k == 2){					//ŃCNg
				Totaltime = Totaltime + 3600;
				if (Totaltime >= 43200){			//120
					Totaltime = 0;
				}
			}
			lcd_goto(LCD_LineNumber1);	//1sڕ\
			lcd_time(Totaltime,0);
			lcd_goto(LCD_LineNumber2);	//2sڕ\
			lcd_time(Totaltime,1);
			lcd_goto(LCD_LineNumber3);	//3sڕ\
			lcd_time(Totaltime,2);	
			lcd_goto(LCD_LineNumber4);	//4sڕ\
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_puts("            ");
		}

		while(k != 0){				//L[̂҂
			k = switchstatus() ;
		}

		while(k != 1){				//̐ݒ	Eꂽ玟
			k = switchstatus() ;				// Get switch status 
			if (k == 2){					//ŃCNg
				if (Totaltime % 3600 >= 3540){		//59̎0 //3540=59*60
					Totaltime = Totaltime / 3600;
					Totaltime = Totaltime * 3600;
				}else{
					Totaltime = Totaltime + 60;
				}
			}
			lcd_goto(LCD_LineNumber1);	//1sڕ\
			lcd_time(Totaltime,0);
			lcd_goto(LCD_LineNumber2);	//2sڕ\
			lcd_time(Totaltime,1);
			lcd_goto(LCD_LineNumber3);	//3sڕ\
			lcd_time(Totaltime,2);	
			lcd_goto(LCD_LineNumber4);	//4sڕ\
			lcd_puts("           ");
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
			lcd_putch(0x01);
		}
	}
}


unsigned char switchstatus(void)
{
	unsigned char tmp = 0;	
	unsigned char switch_status ;
	static unsigned char switch_status_old ,FIL; 

	if ((SW_RIGHT == 0) && (SW_LEFT == 0)){
		switch_status = 3;				//
	}else if  ((SW_RIGHT == 0) && (SW_LEFT == 1)){
		switch_status = 2;				//
	}else if  ((SW_RIGHT == 1) && (SW_LEFT == 0)){
		switch_status = 1;				//E
	}else {
		switch_status = 0;				//ĂȂ
	}

	if (switch_status == FIL){
		tmp = switch_status_old	;					//Olo
		switch_status_old = switch_status	;			//l܂
		tmp = (tmp ^ switch_status) & switch_status	;		//GbWo
	}
	FIL = switch_status;
		
	return (tmp);    
    
  
}



